<?php

function open_image ($file, $mime) {
    switch($mime){
        case "image/jpeg":
            $im = imagecreatefromjpeg($file); //jpeg file
        break;
        case "image/gif":
            $im = imagecreatefromgif($file); //gif file
      break;
      case "image/png":
          $im = imagecreatefrompng($file); //png file
      break;
    default: 
        $im=false;
    break;
    }
    return $im;
}


function isImage($mime){
    switch($mime){
        case "image/jpeg":
            return true;
            break;
        case "image/gif":
            return true;
            break;
        case "image/png":
            return true;
            break;
        default: 
            return false;
            break;
    }
}

function create_image ($image, $mime) {
    switch($mime){
        case "image/jpeg":
            $im = imagejpeg($image); //jpeg file
        break;
        case "image/gif":
            $im = imagegif($image); //gif file
      break;
      case "image/png":
          $im = imagepng($image); //png file
      break;
    default: 
        $im=false;
    break;
    }
    return $im;
}

if (isset($_GET['pid']) & isset($_GET['mimeType'])){

	$pid = $_GET['pid'];
	$mimeType = $_GET['mimeType'];
	
	$xmlString = file_get_contents("http://localhost:8080/fedora/objects/".$_GET['pid']."/datastreams/FILE/content");
	$xml = new SimpleXMLElement($xmlString);
	$arr = (array) $xml;

	$url = "";
	
	// Take into account the position of this script
	$serverPath = "../../../../../../../".$arr['server_path'];

	// If its a supported image	
	if (isImage($mimeType)==true){
		$url = $serverPath;
	}
	else{
		// Remove the file extension from the path
		$withoutExt = preg_replace('/\\.[^.\\s]{3,4}$/', '', $serverPath);
		// Append '_s.jpg' to the file
		$url = $withoutExt.'_s.jpg';
		$mimeType = "image/jpeg";
	}
	
	// Check if image exists (If it doesnt, replace the url with the zamani logo and change the mime type)
	if (!file_exists($url)){
		$url = "http://nala.cs.uct.ac.za/zamaniProject_archive/images/image_not_available.png";
		$mimeType = "image/png";
	}	
	
	$originalImage = open_image($url, $mimeType);

	if ($originalImage === false) { die ('Unable to open image'); }

	// Get images width and height
	$w = imagesx($originalImage);
	$h = imagesy($originalImage);
	
	//calculate new image dimensions (preserve aspect)
	$max_dimension = 500;
	
	// Calculate max new width
	if (isset($_GET['w'])){
		if ($_GET['w'] > $max_dimension){
			$new_w = $max_dimension;
		}
		else{
			$new_w = $_GET['w'];
		}
	}
	else{
		$new_w = $max_dimension;
	}

	// Calculate max new height
	if (isset($_GET['h'])){
		if ($_GET['h'] > $max_dimension){
			$new_h = $max_dimension;
		}
		else{
			$new_h = $_GET['h'];
		}
	}
	else{
		$new_h = $max_dimension;
	}
	
	// Scale and maintain aspect ratio		
	//---------------------
	if($w > $h) 
	{
		$thumb_w    =   $new_w;
		$thumb_h    =   $h*($new_h/$w);
	}

	if($w < $h) 
	{
		$thumb_w    =   $w*($new_w/$h);
		$thumb_h    =   $new_h;
	}

	if($w == $h) 
	{
		$thumb_w    =   $new_w;
		$thumb_h    =   $new_h;
	}
	//---------------------
	
	$im2 = ImageCreateTrueColor($thumb_w, $thumb_h);
	imagecopyresized ($im2, $originalImage, 0, 0, 0, 0, $thumb_w, $thumb_h, $w, $h);
	header('Content-type: '.$mimeType);
	// Cache for 1 day (seconds)
	header('Max-Age: 86400');
	create_image($im2, $mimeType);
	imagedestroy($originalImage);
	imagedestroy($im2);	
}
?>